# std::variant::emplace

From cppreference.com
< cpp‎ | utility‎ | variant

template <class T, class... Args> T& emplace(Args&&... args); | (1) | (since C++17)
template <class T, class U, class... Args> T& emplace(std::initializer_list<U> il, Args&&... args); | (2) | (since C++17)
template <size_t I, class... Args> std::variant_alternative_t<I, variant>& emplace(Args&&... args); | (3) | (since C++17)
template <size_t I, class U, class... Args> std::variant_alternative_t<I, variant>& emplace(std::initializer_list<U> il, Args&&... args); | (4) | (since C++17)

Creates a new value in-place, in an existing `variant` object

1) Equivalent to emplace<I>(std::forward<Args>(args)...), where `I` is the zero-based index of `T` in `Types...`. This overload only participates in overload resolution if `std::is_constructible_v<T, Args...>` is `true`, and `T` occurs exactly once in `Types...`
2) Equivalent to emplace<I>(il, std::forward<Args>(args)...), where `I` is the zero-based index of `T` in `Types...`. This overload only participates in overload resolution if `std::is_constructible_v<T, std::initializer_list<U>&, Args...>` is `true`, and `T` occurs exactly once in `Types...`
3) First, destroys the currently contained value (if any). Then direct-initializes the contained value as if constructing a value of type `T_I` with the arguments std::forward<Args>(args).... If an exception is thrown, `*this` may become valueless_by_exception. This overload only participates in overload resolution if `std::is_constructible_v<T_I, Args...>` is `true`. The behavior is undefined if `I` is not less than sizeof...(Types).
4) First, destroys the currently contained value (if any). Then direct-initializes the contained value as if constructing a value of type `T_I` with the arguments il, std::forward<Args>(args).... If an exception is thrown, `*this` may become valueless_by_exception. This overload only participates in overload resolution if `std::is_constructible_v<T_I, initializer_list<U>&, Args...>` is `true`. The behavior is undefined if `I` is not less than sizeof...(Types).

### Parameters

args | - | constructor arguments to use when constructing the new value
il | - | initializer_list argument to use when constructing the new value

### Return value

A reference to the new contained value.

### Exceptions

1-4) Any exception thrown during the initialization of the contained value.

### Example

| This section is incomplete Reason: no example

### See also

operator= | assigns a variant (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/utility/variant/emplace&oldid=91291"
Category:

- Todo no example